diff -uNrd ircd-hybrid-6.3.1.dist/src/s_user.c ircd-hybrid-6.3.1/src/s_user.c
--- ircd-hybrid-6.3.1.dist/src/s_user.c	Wed Jan 23 13:39:08 2002
+++ ircd-hybrid-6.3.1/src/s_user.c	Sat Apr 26 19:35:03 2003
@@ -53,6 +53,8 @@
 #include "dbuf.h"
 #endif
 
+#include "m_flags.h"
+
 #include <string.h>
 #include <stdlib.h>
 #include <unistd.h>
@@ -75,6 +77,7 @@
 
 static FLAG_ITEM user_modes[] =
 { 
+  {FLAGS_ADMIN, 'a'},
   {FLAGS_BOTS,  'b'},
   {FLAGS_CCONN, 'c'},
   {FLAGS_DEBUG, 'd'},
@@ -90,6 +93,9 @@
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+  {FLAGS_LOCOPS, 'l'},
+  {FLAGS_UNAUTH, 'u'},
+  {FLAGS_JUPE, 'j'},
   {0, 0}
 };
 
@@ -130,7 +136,7 @@
   0,            /* Z 0x5A */
   0, 0, 0, 0, 0, /* 0x5F */ 
   /* 0x60 */       0,
-  0,            /* a */
+  FLAGS_ADMIN,  /* a */
   FLAGS_BOTS,   /* b */
   FLAGS_CCONN,  /* c */
   FLAGS_DEBUG,  /* d */
@@ -139,9 +145,9 @@
   0,            /* g */
   0,            /* h */
   FLAGS_INVISIBLE, /* i */
-  0,            /* j */
+  FLAGS_JUPE,   /* j */
   FLAGS_SKILL,  /* k */
-  0,            /* l */
+  FLAGS_LOCOPS, /* l */
   0,            /* m */
   FLAGS_NCHANGE, /* n */
   FLAGS_OPER,   /* o */
@@ -150,7 +156,7 @@
   FLAGS_REJ,    /* r */
   FLAGS_SERVNOTICE, /* s */
   0,            /* t */
-  0,            /* u */
+  FLAGS_UNAUTH, /* u */
   0,            /* v */
   FLAGS_WALLOP, /* w */
   FLAGS_EXTERNAL, /* x */
@@ -171,7 +177,18 @@
 
 unsigned long my_rand(void);    /* provided by orabidoo */
 
-
+char oper_type_char(struct Client *cptr)
+{
+  /* This should never happen -Hwy */
+  if (!IsAnOper(cptr))
+    return 'x';
+  if (cptr->umodes & FLAGS_ADMIN)
+    return 'A';
+  if (IsOper(cptr))
+    return 'O';
+  /* else */
+  return 'o';
+}
 
 /*
  * show_opers - send the client a list of opers
@@ -191,7 +208,7 @@
         {
           sendto_one(cptr, ":%s %d %s :[%c][%s] %s (%s@%s) Idle: %d",
                      me.name, RPL_STATSDEBUG, cptr->name,
-                     IsOper(cptr2) ? 'O' : 'o',
+                     oper_type_char(cptr2),
                      oper_privs_as_string(cptr2,
                                           cptr2->confs->value.aconf->port),
                      cptr2->name,
@@ -202,7 +219,7 @@
         {
           sendto_one(cptr, ":%s %d %s :[%c] %s (%s@%s) Idle: %d",
                      me.name, RPL_STATSDEBUG, cptr->name,
-                     IsOper(cptr2) ? 'O' : 'o',
+                     oper_type_char(cptr2),
                      cptr2->name,
                      cptr2->username, cptr2->host,
                      CurrentTime - cptr2->user->last);
@@ -225,6 +242,9 @@
   static int    o_count = 0, m_client = 0, m_servers = 0;
   int forced;
   struct Client *acptr;
+#ifdef SAVE_MAXCLIENT
+  static time_t last_stat_save = 0;
+#endif
 
 /*  forced = (parc >= 2); */
   forced = (IsAnOper(sptr) && (parc > 3));
@@ -340,6 +360,14 @@
           Count.unknown = u_count;
         } /* Complain & reset loop */
     } /* Recount loop */
+
+#ifdef SAVE_MAXCLIENT
+  if ((CurrentTime - last_stat_save) > SAVE_TIME)
+    {
+      write_stats();
+      last_stat_save = CurrentTime;
+    }
+#endif
   
 #ifndef SHOW_INVISIBLE_LUSERS
   if (IsAnOper(sptr) && i_count)
@@ -479,6 +507,105 @@
   return (ch - nick);
 }
 
+/*
+ *  check_clones
+ *    This function counts the number of clients with the
+ *    same host as cptr that connected less than CHECK_CLONE_PERIOD
+ *    seconds ago.
+ *  return value
+ *    -1: reject connections
+ *     0: permit connections
+ *  -SeKs -record
+ */
+#ifdef CHECK_CLONE
+static int check_clones(aClient * cptr)
+{
+  struct abacklog
+  {
+    time_t last;
+    char host[HOSTLEN];
+    int count;
+    struct abacklog *next;
+  };
+
+  static struct abacklog *backlog = NULL;
+  struct abacklog **blscn = &backlog, *blptr;
+  Link  *tmp;
+
+  /* First, check to see if any of the conf items associated with this
+  ** user define it as "Clone Exempt"
+  */
+  for (tmp = cptr->confs; tmp; tmp = tmp->next)
+  {
+    if (!tmp->value.aconf)
+      continue;
+    if (IsConfCloneExempt(tmp->value.aconf))
+      return 0;
+  }
+
+  /* Find the host we're interested in. While we're at it, we'll
+   * clean out expired elements from the list.                    */
+
+  while ((*blscn != NULL) && (strcmp(cptr->host, (*blscn)->host)))
+  {
+    if ((*blscn)->last + GlobalSetOptions.clone_period < CurrentTime)
+    {                           /* expired; remove */
+      if ((*blscn)->count == -1)
+        sendto_realops_flags(FLAGS_REJ,"Removing throttle for %s.",
+          (*blscn)->host);
+      blptr = *blscn;
+      *blscn = blptr->next;
+      MyFree((char *)blptr);
+    }
+    else
+      blscn = &(*blscn)->next;
+  }
+
+  if (*blscn)                   /* There is a record for this host */
+  {
+    if (!((*blscn)->last + GlobalSetOptions.clone_period < CurrentTime))   /* not expired */
+    {
+      (*blscn)->last = CurrentTime;
+      if ((*blscn)->count == -1)
+        return (-1);
+      else
+      {
+        (*blscn)->count++;
+        if (((*blscn)->count == GlobalSetOptions.clone_num) && !IsFlined(cptr))
+        {
+          sendto_realops_flags(FLAGS_REJ,"Throttling connections from %s.",
+            (*blscn)->host);
+          (*blscn)->count = -1;
+          return (-1);
+        }
+        else
+          return (0);
+      }
+    }
+    else
+      /* expired */
+    {
+      if ((*blscn)->count == -1)
+        sendto_realops_flags(FLAGS_REJ,"Removing throttle for %s.",
+          (*blscn)->host);
+      (*blscn)->last = CurrentTime;
+      (*blscn)->count = 1;
+      return (0);
+    }
+  }
+  else
+    /* no record for host; make one */
+  {
+    blptr = (struct abacklog *)MyMalloc(sizeof(struct abacklog));
+    strncpy_irc(blptr->host, cptr->host, HOSTLEN);
+    blptr->next = backlog;
+    blptr->last = CurrentTime;
+    blptr->count = 1;
+    backlog = blptr;
+    return (0);
+  }
+}
+#endif
 
 /*
 ** register_user
@@ -504,7 +631,7 @@
 **         nick from local user or kill him/her...
 */
 
-static int register_user(aClient *cptr, aClient *sptr, 
+int register_user(aClient *cptr, aClient *sptr, 
                          char *nick, char *username)
 {
   aConfItem*  aconf;
@@ -571,7 +698,7 @@
               ServerStats->is_ref++;
 	/* jdc - lists server name & port connections are on */
 	/*       a purely cosmetical change */
-              sendto_realops_flags(FLAGS_CCONN,
+              sendto_realops_flags(FLAGS_UNAUTH,
 				 "%s from %s [%s] on [%s/%u].",
                                  "Unauthorized client connection",
                                  get_client_host(sptr),
@@ -655,7 +782,12 @@
         }
 
       /* password check */
+#ifdef CRYPT_AUTH_PASSWORD
+      if (!BadPtr(aconf->passwd) && 0 != strcmp(crypt(sptr->passwd,
+                                   aconf->passwd), aconf->passwd))
+#else
       if (!BadPtr(aconf->passwd) && 0 != strcmp(sptr->passwd, aconf->passwd))
+#endif
         {
           ServerStats->is_ref++;
           sendto_one(sptr, form_str(ERR_PASSWDMISMATCH),
@@ -700,6 +832,25 @@
         }
       /* end of valid user name check */
 
+#ifdef CHECK_CLONE
+
+       /*
+        * Add this local client into the clone check database.  If the
+        * site has been throttled, reject the user. -SeKs -record
+        */
+
+       if (check_clones(sptr) == -1
+#ifdef CHECK_CLONE_DELAY
+           && me.since + CHECK_CLONE_DELAY < CurrentTime
+#endif
+           )
+       {
+         ServerStats->is_ref++;
+         return exit_client(cptr, sptr, &me,
+           "Too many connections from your host -- throttled");
+       }
+#endif
+
       if(!IsAnOper(sptr))
         {
           char *xreason;
@@ -738,13 +889,21 @@
 #endif
 
       sendto_realops_flags(FLAGS_CCONN,
+#ifdef GECOS_CLICONNECT
+                         "Client connecting: %s (%s@%s) [%s] {%d} [%s]",
+#else
                          "Client connecting: %s (%s@%s) [%s] {%d}",
+#endif
                          nick, sptr->username, sptr->host,
 #ifdef HIDE_SPOOF_IPS
                          IsIPSpoof(sptr) ? "255.255.255.255" : 
 #endif /* HIDE_SPOOF_IPS */
                          inetntoa((char *)&sptr->ip),
+#ifdef GECOS_CLICONNECT
+                         get_client_class(sptr), sptr->info);
+#else
                          get_client_class(sptr));
+#endif
 
       if(IsInvisible(sptr))
         Count.invisi++;
@@ -773,6 +932,7 @@
       return exit_client(NULL, sptr, &me, "Ghost");
     }
   add_client_to_llist(&(sptr->servptr->serv->users), sptr);
+  sptr->servptr->serv->usercnt++;
 
 /* Increment our total user count here */
   if (++Count.total > Count.max_tot)
@@ -780,7 +940,8 @@
 
   if (MyConnect(sptr))
     {
-      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, nick);
+      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, NETWORK_NAME,
+                 nick, sptr->username, inetntoa((char *)&sptr->ip));
       /* This is a duplicate of the NOTICE but see below...*/
       sendto_one(sptr, form_str(RPL_YOURHOST), me.name, nick,
                  get_listener_name(sptr->listener), ircd_version);
@@ -823,18 +984,24 @@
 #else
       SendMessageFile(sptr, &ConfigFileEntry.motd);
 #endif
-      
+
 #ifdef LITTLE_I_LINES
       if(sptr->confs && sptr->confs->value.aconf &&
          (sptr->confs->value.aconf->flags
           & CONF_FLAGS_LITTLE_I_LINE))
         {
           SetRestricted(sptr);
-          sendto_one(sptr,"NOTICE %s :*** Notice -- You are in a restricted access mode",nick);
-          sendto_one(sptr,"NOTICE %s :*** Notice -- You can not chanop others",nick);
+          sendto_one(sptr,form_str(ERR_RESTRICTED),me.name, sptr->name);
         }
 #endif
 
+#if defined(FLAGS_COMMAND) && defined(FLAGS_ANNOUNCE)
+      sendto_one(sptr, ":%s NOTICE %s :Current flags:%s",
+                 me.name, parv[0], set_flags_to_string(sptr));
+      sendto_one(sptr, ":%s NOTICE %s :Current missing flags:%s",
+                 me.name, parv[0], unset_flags_to_string(sptr));
+#endif
+
 #ifdef NEED_SPLITCODE
       if (server_was_split)
         {
@@ -1196,6 +1363,11 @@
 
               sendto_common_channels(sptr, ":%s NICK :%s", parv[0], nick);
               if (sptr->user)
+#ifdef ANTI_IP_SPOOF
+       /* Don't send out a nick-change if they haven't PONG'd us
+        * because they haven't registered yet if they haven't! -JailBird */
+       if ((!MyConnect(sptr)) || (sptr->flags2 & FLAGS2_GOT_ANTI_SPOOF_PING)) 
+#endif
                 {
                   add_history(sptr,1);
               
@@ -1245,6 +1417,19 @@
           ** may reject the client and call exit_client for it
           ** --must test this and exit m_nick too!!!
           */
+/* anti ip sequence prediction spoof code
+   it needs a good going over by someone else, but it
+   works... -Dianora
+*/
+#ifdef ANTI_IP_SPOOF
+       if(MyConnect(sptr))
+       {
+               strcpy(sptr->name,nick);
+               sptr->random_ping = (unsigned int)my_rand();
+               sendto_one(sptr, "PING :%u", sptr->random_ping);
+               sptr->flags |= FLAGS_PINGSENT;
+       } else
+#endif
             if (register_user(cptr, sptr, nick, buf) == CLIENT_EXITED)
               return CLIENT_EXITED;
         }
@@ -1921,6 +2106,22 @@
     }
   strncpy_irc(sptr->info, realname, REALLEN);
 
+#ifdef ANTI_IP_SPOOF
+  user->last = CurrentTime;
+  if(MyConnect(sptr))
+     {
+       if (sptr->name[0]) /* NICK already received, now I have USER... */
+         {
+          sptr->random_ping = (unsigned int)my_rand();
+          sendto_one(sptr, "PING :%u", sptr->random_ping);
+          sptr->flags |= FLAGS_PINGSENT;  
+        }
+       if (!IsGotId(sptr))
+         strncpy_irc(sptr->username, username, USERLEN);
+       return 0;
+     } 
+#endif
+
   if (sptr->name[0]) /* NICK already received, now I have USER... */
     return register_user(cptr, sptr, sptr->name, username);
   else
@@ -2048,6 +2249,11 @@
                   aClient *prev_cptr = (aClient *)NULL;
                   aClient *cur_cptr = oper_cptr_list;
 
+#ifdef DEOPER_NOTICE
+                  sendto_realops_flags(FLAGS_SPY,
+                     "operator %s has removed operator status", sptr->name);
+#endif
+
                   fdlist_delete(sptr->fd, FDL_OPER | FDL_BUSY);
                   detach_conf(sptr,sptr->confs->value.aconf);
                   sptr->flags2 &= ~(FLAGS2_OPER_GLOBAL_KILL|
@@ -2109,6 +2315,13 @@
       sptr->umodes &= ~FLAGS_NCHANGE; /* only tcm's really need this */
     }
 
+  if (MyOper(sptr) && (sptr->umodes & FLAGS_ADMIN) && !IsSetOperAdmin(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :*** You need oper and A flag for +a",
+                 me.name,parv[0]);
+      sptr->umodes &= ~FLAGS_ADMIN;
+    }
+
   if (!(setflags & FLAGS_INVISIBLE) && IsInvisible(sptr))
     ++Count.invisi;
   if ((setflags & FLAGS_INVISIBLE) && !IsInvisible(sptr))
@@ -2204,5 +2417,30 @@
     }
 
   if (cptr && MyClient(cptr))
-    send_umode(cptr, sptr, old, ALL_UMODES, buf);
+    {
+      send_umode(cptr, sptr, old, ALL_UMODES, buf);
+#if defined(FLAGS_COMMAND) && defined(FLAGS_ANNOUNCE)
+      sendto_one(cptr, ":%s NOTICE %s :Current flags:%s",
+                 me.name, cptr->name, set_flags_to_string(cptr));
+      sendto_one(cptr, ":%s NOTICE %s :Current missing flags:%s",
+                 me.name, cptr->name, unset_flags_to_string(cptr));
+#endif
+    }
 }
+
+#ifdef POST_REGISTER
+int
+m_webproxy(aClient *cptr, aClient *sptr, int parc, char *parv[])
+{
+  if (IsUnknown(sptr) && MyConnect(sptr))
+  {
+    sendto_realops_flags(FLAGS_REJ,
+                         "HTTP Proxy disconnected: [%s@%s]",
+                         cptr->username, cptr->host);
+    return m_quit(cptr, sptr, parc, parv);
+  }
+  else
+    return 0;
+}
+#endif
+
diff -uNrd ircd-hybrid-6.3.1.dist/src/s_zip.c ircd-hybrid-6.3.1/src/s_zip.c
--- ircd-hybrid-6.3.1.dist/src/s_zip.c	Mon Jun  4 01:07:19 2001
+++ ircd-hybrid-6.3.1/src/s_zip.c	Sat Apr 19 21:06:45 2003
@@ -283,7 +283,7 @@
 
     default: /* error ! */
       /* should probably mark link as dead or something... */
-      sendto_realops("inflate() error(%d): %s", r,
+      sendto_realops("inflate() error(%d): %s: %s", r, zError(r),
                   (zin->msg) ? zin->msg : "?");
       *length = -1; /* report error condition */
       break;
@@ -340,7 +340,8 @@
       return zipbuf;
 
     default: /* error ! */
-      sendto_realops("deflate() error(%d): %s", r, (zout->msg) ? zout->msg : "?");
+      sendto_realops("deflate() error(%d): %s: %s", r, zError(r),
+                     (zout->msg) ? zout->msg : "?");
       *length = -1;
       break;
     }
diff -uNrd ircd-hybrid-6.3.1.dist/src/send.c ircd-hybrid-6.3.1/src/send.c
--- ircd-hybrid-6.3.1.dist/src/send.c	Sat Feb  2 15:58:30 2002
+++ ircd-hybrid-6.3.1/src/send.c	Fri May  2 18:24:22 2003
@@ -674,7 +674,7 @@
  */
 void
 send_knock(aClient *sptr, aClient *cptr, aChannel *chptr, int type, 
-           char *message, char *key)
+           char *name, char *key)
 {
   Link *lp;
   aClient *acptr;
@@ -694,8 +694,8 @@
       
     if(MyClient(acptr))
     {
-      sendto_prefix_one(acptr, sptr, ":%s NOTICE %s :%s",
-                        sptr->name, acptr->name, message);
+      sendto_one(acptr, form_str(RPL_KNOCK), me.name, name, name,
+                 sptr->name, sptr->username, sptr->host);
       continue;
     }
 
@@ -710,9 +710,14 @@
 
         sentalong[lindex] = current_serial;
       }
+#if 0
+      /* 7 and ratbox don't propagate this.  With this rewrite, we probably
+      ** shouldn't either.
+      */
       else
         sendto_one(acptr, ":%s NOTICE %s :%s",
 	           sptr->name, acptr->name, message);
+#endif
     }
   }
 }
@@ -1215,7 +1220,7 @@
 */
 
 void
-send_operwall(aClient *from, char *type_message, char *message)
+send_operwall(aClient *from, char *type_message, char *message, int locops)
 
 {
   char sender[NICKLEN + USERLEN + HOSTLEN + 5];
@@ -1245,10 +1250,21 @@
 
   for (acptr = oper_cptr_list; acptr; acptr = acptr->next_oper_client)
     {
-      if (!SendOperwall(acptr))
-        continue; /* has to be oper if in this linklist */
+      /* kludge - operwall isnt used often enough for it to affect stuff */
+      if(locops)
+      {
+        if(!SendLocops(acptr))
+          continue;
 
-      sendto_one(acptr, ":%s WALLOPS :%s - %s", sender, type_message, message);
+       sendto_one(acptr, ":%s WALLOPS :%s - %s", sender, type_message, message);
+      }
+      else
+      {
+        if (!SendOperwall(acptr))
+          continue; /* has to be oper if in this linklist */
+
+        sendto_one(acptr, ":%s WALLOPS :%s - %s", sender, type_message, message);
+      }
     }
 } /* send_operwall() */
 
@@ -1525,52 +1541,3 @@
       (void)send_queued(cptr);
 } /* flush_server_connections() */
 
-#ifdef SLAVE_SERVERS
-
-extern aConfItem *u_conf;
-
-int
-sendto_slaves(aClient *one, char *message, char *nick, int parc, char *parv[])
-
-{
-  aClient *acptr;
-  aConfItem *aconf;
-
-  for(acptr = serv_cptr_list; acptr; acptr = acptr->next_server_client)
-    {
-      if (one == acptr)
-        continue;
-      
-      for (aconf = u_conf; aconf; aconf = aconf->next)
-        {
-          if (match(acptr->name,aconf->name))
-            { 
-              if(parc > 3)
-                sendto_one(acptr,":%s %s %s %s %s :%s",
-                           me.name,
-                           message,
-                           nick,
-                           parv[1],
-                           parv[2],
-                           parv[3]);
-              else if(parc > 2)
-                sendto_one(acptr,":%s %s %s %s :%s",
-                           me.name,
-                           message,
-                           nick,
-                           parv[1],
-                           parv[2]);
-              else if(parc > 1)
-                sendto_one(acptr,":%s %s %s :%s",
-                           me.name,
-                           message,
-                           nick,
-                           parv[1]);
-            } /* if (match(acptr->name,aconf->name)) */
-        } /* for (aconf = u_conf; aconf; aconf = aconf->next) */
-    } /* for(acptr = serv_cptr_list; acptr; acptr = acptr->next_server_client) */
-
-  return 0;
-} /* sendto_slaves() */
-
-#endif /* SLAVE_SERVERS */
diff -uNrd ircd-hybrid-6.3.1.dist/src/sprintf_irc.c ircd-hybrid-6.3.1/src/sprintf_irc.c
--- ircd-hybrid-6.3.1.dist/src/sprintf_irc.c	Sat Dec  8 12:55:06 2001
+++ ircd-hybrid-6.3.1/src/sprintf_irc.c	Sat Apr 19 21:06:45 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sprintf_irc.c,v 1.11 2001/12/08 17:55:06 db Exp $
+ *   $Id: sprintf_irc.c,v 1.12 2002/06/12 19:31:22 androsyn Exp $
  */
 #include "sprintf_irc.h"
 
@@ -305,6 +305,12 @@
 
                                 ++format;
                                 v1 = va_arg(args, unsigned long);
+                                if(v1 == 0)
+                                {
+                                  *str++ = '0';
+                                  ++bytes;
+                                  continue;
+                                }
                                 if (v1 > 999999999L)
                                 {
                                         v2 = v1 / 1000000000;
diff -uNrd ircd-hybrid-6.3.1.dist/tools/install_ircd ircd-hybrid-6.3.1/tools/install_ircd
--- ircd-hybrid-6.3.1.dist/tools/install_ircd	Tue Jul  3 17:52:19 2001
+++ ircd-hybrid-6.3.1/tools/install_ircd	Sat Apr 19 21:24:03 2003
@@ -140,16 +140,16 @@
   echo installing viconf as ${DPATH}viconf${EXESUFFIX}
   $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX}
   rm -f ${DPATH}vimotd${EXESUFFIX} ${DPATH}viklines${EXESUFFIX}
-  ln ${DPATH}viconf${EXESUFFIX} ${DPATH}vimotd${EXESUFFIX}
-  ln ${DPATH}viconf${EXESUFFIX} ${DPATH}viklines${EXESUFFIX};
+  ln -s ${DPATH}viconf${EXESUFFIX} ${DPATH}vimotd${EXESUFFIX}
+  ln -s ${DPATH}viconf${EXESUFFIX} ${DPATH}viklines${EXESUFFIX};
 else
    echo installing viconf as ${DPATH}viconf${EXESUFFIX}
    echo previous viconf saved as viconf${EXESUFFIX}.old
    mv ${DPATH}viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX}.old
    $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX}
    rm -f ${DPATH}vimotd${EXESUFFIX} ${DPATH}viklines${EXESUFFIX}
-   ln ${DPATH}viconf${EXESUFFIX} ${DPATH}vimotd${EXESUFFIX}
-   ln ${DPATH}viconf${EXESUFFIX} ${DPATH}viklines${EXESUFFIX};
+   ln -s ${DPATH}viconf${EXESUFFIX} ${DPATH}vimotd${EXESUFFIX}
+   ln -s ${DPATH}viconf${EXESUFFIX} ${DPATH}viklines${EXESUFFIX};
 fi
 
 # install ircd.8
diff -uNrd ircd-hybrid-6.3.1.dist/tools/mkpasswd.c ircd-hybrid-6.3.1/tools/mkpasswd.c
--- ircd-hybrid-6.3.1.dist/tools/mkpasswd.c	Thu Oct 25 00:28:51 2001
+++ ircd-hybrid-6.3.1/tools/mkpasswd.c	Thu May  8 12:44:01 2003
@@ -5,44 +5,66 @@
 ** md5 patch by W. Campbell <wcampbel@botbay.net>
 ** Modernization, getopt, etc for the Hybrid IRCD team
 ** by W. Campbell
+** 
+** /dev/random for salt generation added by 
+** Aaron Sethman <androsyn@ratbox.org>
 **
-** $Id: mkpasswd.c,v 1.11 2001/10/25 04:28:51 wcampbel Exp $
+** $Id: mkpasswd.c,v 1.32 2003/05/05 18:06:37 wcampbel Exp $
 */
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 #include <time.h>
 #include <unistd.h>
+#include <fcntl.h>
 
 #define FLAG_MD5     0x00000001
 #define FLAG_DES     0x00000002
 #define FLAG_SALT    0x00000004
 #define FLAG_PASS    0x00000008
 #define FLAG_LENGTH  0x00000010
+#define FLAG_BLOWFISH 0x00000020
+#define FLAG_ROUNDS  0x00000040
+#define FLAG_EXT     0x00000080
+#define FLAG_RAW     0x00000100
 
 extern char *getpass();
 extern char *crypt();
 
 char *make_des_salt();
+char *make_ext_salt(int);
+char *make_ext_salt_para(int, char *);
 char *make_md5_salt(int);
 char *make_md5_salt_para(char *);
-void usage();
-static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
+char *make_bf_salt(int, int);
+char *make_bf_salt_para(int, char *);
+char *int_to_base64(int);
+char *generate_random_salt(char *, int);
+char *generate_poor_salt(char *, int);
+
+void full_usage();
+void brief_usage();
+
+static char saltChars[] =
+       "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
+       /* 0 .. 63, ascii - 64 */
 
 int main(int argc, char *argv[])
 {
   char *plaintext = NULL;
   extern char *optarg;
-  extern int optind;
   int c;
   char *saltpara = NULL;
   char *salt;
   int flag = 0;
-  int length = 8;
-
-  srandom(time(NULL));
+  int length = 0; /* Not Set */
+  int rounds = 0; /* Not set, since extended DES needs 25 and blowfish needs
+                  ** 4 by default, a side effect of this being the encryption
+                  ** type parameter must be specified before the rounds
+                  ** parameter.
+                  */
 
-  while( (c=getopt(argc, argv, "mdh?l:s:p:")) != -1)
+  while( (c=getopt(argc, argv, "mdber:h?l:s:p:R:")) != -1)
   {
     switch(c)
     {
@@ -52,10 +74,22 @@
       case 'd':
         flag |= FLAG_DES;
         break;
+      case 'b':
+        flag |= FLAG_BLOWFISH;
+        rounds = 4;
+        break;
+      case 'e':
+        flag |= FLAG_EXT;
+        rounds = 25;
+        break;
       case 'l':
         flag |= FLAG_LENGTH;
         length = atoi(optarg);
         break;
+      case 'r':
+        flag |= FLAG_ROUNDS;
+        rounds = atoi(optarg);
+        break;
       case 's':
         flag |= FLAG_SALT;
         saltpara = optarg;
@@ -64,9 +98,17 @@
         flag |= FLAG_PASS;
         plaintext = optarg;
         break;
+      case 'R':
+        flag |= FLAG_RAW;
+        saltpara = optarg;
+        break;
       case 'h':
+        full_usage();
+        /* NOT REACHED */
+        break;
       case '?':
-        usage();
+        brief_usage();
+        /* NOT REACHED */
         break;
       default:
         printf("Invalid Option: -%c\n", c);
@@ -76,12 +118,47 @@
 
   if (flag & FLAG_MD5)
   {
+    if (length == 0)
+      length = 8;
     if (flag & FLAG_SALT)
       salt = make_md5_salt_para(saltpara);
     else
       salt = make_md5_salt(length);
   }
-  else
+  else if (flag & FLAG_BLOWFISH)
+  {
+    if (length == 0)
+      length = 22;
+    if (flag & FLAG_SALT)
+      salt = make_bf_salt_para(rounds, saltpara);
+    else
+      salt = make_bf_salt(rounds, length);
+  }
+  else if (flag & FLAG_EXT)
+  {
+    /* XXX - rounds needs to be done */
+    if (flag & FLAG_SALT)
+    {
+      if ((strlen(saltpara) == 4))
+      {
+        salt = make_ext_salt_para(rounds, saltpara);
+      }
+      else
+      {
+        printf("Invalid salt, please enter 4 alphanumeric characters\n");
+        exit(1);
+      }
+    }
+    else
+    {
+      salt = make_ext_salt(rounds);
+    }
+  }
+  else if (flag & FLAG_RAW)
+  {
+    salt = saltpara;
+  }
+  else /* Default to DES */
   {
     if (flag & FLAG_SALT)
     {
@@ -118,12 +195,46 @@
 char *make_des_salt()
 {
   static char salt[3];
-  salt[0] = saltChars[random() % 64];
-  salt[1] = saltChars[random() % 64];
+  generate_random_salt(salt, 2);
   salt[2] = '\0';
   return salt;
 }
 
+char *int_to_base64(int value)
+{
+  static char buf[5];
+  int i;
+
+  for (i = 0; i < 4; i++)
+  {
+    buf[i] = saltChars[value & 63];
+    value >>= 6;  /* Right shifting 6 places is the same as dividing by 64 */
+  }
+
+  buf[i] = '\0';  /* not REALLY needed as it's static, and thus initialized
+                  ** to \0.
+                  */
+  return buf;
+}
+
+char *make_ext_salt(int rounds)
+{
+  static char salt[10];
+
+  sprintf(salt, "_%s", int_to_base64(rounds));
+  generate_random_salt(&salt[5], 4);
+  salt[9] = '\0';
+  return salt;
+}
+
+char *make_ext_salt_para(int rounds, char *saltpara)
+{
+  static char salt[10];
+
+  sprintf(salt, "_%s%s", int_to_base64(rounds), saltpara);
+  return salt;
+}
+
 char *make_md5_salt_para(char *saltpara)
 {
   static char salt[21];
@@ -145,7 +256,6 @@
 char *make_md5_salt(int length)
 {
   static char salt[21];
-  int i;
   if (length > 16)
   {
     printf("MD5 salt length too long\n");
@@ -154,21 +264,112 @@
   salt[0] = '$';
   salt[1] = '1';
   salt[2] = '$';
-  for (i=3; i<(length+3); i++)
-    salt[i] = saltChars[random() % 64];
+  generate_random_salt(&salt[3], length);
   salt[length+3] = '$';
   salt[length+4] = '\0';
   return salt;
 }
 
-void usage()
+char *make_bf_salt_para(int rounds, char *saltpara)
 {
-  printf("mkpasswd [-m|-d] [-l saltlength] [-s salt] [-p plaintext]\n");
+  static char salt[31];
+  char tbuf[3];
+  if (saltpara && (strlen(saltpara) <= 22))
+  {
+    /* sprintf used because of portability requirements, the length
+    ** is checked above, so it should not be too much of a concern
+    */
+    sprintf(tbuf, "%02d", rounds);
+    sprintf(salt, "$2a$%s$%s$", tbuf, saltpara);
+    return salt;
+  }
+  printf("Invalid Salt, please use up to 22 random alphanumeric characters\n");
+  exit(1);
+
+  /* NOT REACHED */
+  return NULL;
+}
+
+char *make_bf_salt(int rounds, int length)
+{
+  static char salt[31];
+  char tbuf[3];
+  if (length > 22)
+  {
+    printf("BlowFish salt length too long\n");
+    exit(0);
+  }
+  sprintf(tbuf, "%02d", rounds);
+  sprintf(salt, "$2a$%s$", tbuf);
+  generate_random_salt(&salt[7], length);
+  salt[length+7] = '$';
+  salt[length+8] = '\0';
+  return salt;
+}
+
+char *generate_poor_salt(char *salt, int length)
+{
+  int i;
+  srandom(time(NULL));
+  for(i = 0; i < length; i++)
+  {
+    salt[i] = saltChars[random() % 64];
+  }
+  return(salt);
+}
+
+char *generate_random_salt(char *salt, int length)
+{
+  char *buf;
+  int fd, i;
+  if((fd = open("/dev/random", O_RDONLY)) < 0)
+  {
+    return(generate_poor_salt(salt, length));	
+  }
+  buf = calloc(1, length);
+  if(read(fd, buf, length) != length)
+  {
+    free(buf);
+    return(generate_poor_salt(salt, length));
+  }
+	
+  for(i = 0; i < length; i++)
+  {
+    salt[i] = saltChars[abs(buf[i]) % 64];
+  }
+  free(buf);
+  return(salt);
+}
+
+void full_usage()
+{
+  printf("mkpasswd [-m|-d|-b|-e] [-l saltlength] [-r rounds] [-s salt] [-p plaintext]\n");
+  printf("         [-R rawsalt]\n");
   printf("-m Generate an MD5 password\n");
   printf("-d Generate a DES password\n");
-  printf("-l Specify a length for a random MD5 salt\n");
-  printf("-s Specify a salt, 2 alphanumeric characters for DES, up to 16 for MD5\n");
+  printf("-b Generate a BlowFish password\n");
+  printf("-e Generate an Extended DES password\n");
+  printf("-l Specify a length for a random MD5 or BlowFish salt\n");
+  printf("-r Specify a number of rounds for a BlowFish or Extended DES password\n");
+  printf("   BlowFish:  default 4, no more than 6 recommended\n");
+  printf("   Extended DES:  default 25\n");
+  printf("-s Specify a salt, 2 alphanumeric characters for DES, up to 16 for MD5,\n");
+  printf("   up to 22 for BlowFish, and 4 for Extended DES\n");
   printf("-p Specify a plaintext password to use\n");
+  printf("-R Specify a raw salt passed directly to crypt()\n");
   printf("Example: mkpasswd -m -s 3dr -p test\n");
+  exit(0);
+}
+
+void brief_usage()
+{
+  printf("mkpasswd - password hash generator\n");
+  printf("Standard DES:  mkpasswd [-d] [-s salt] [-p plaintext]\n");
+  printf("Extended DES:  mkpasswd -e [-r rounds] [-s salt] [-p plaintext]\n");
+  printf("         MD5:  mkpasswd -m [-l saltlength] [-s salt] [-p plaintext]\n");
+  printf("    BlowFish:  mkpasswd -b [-r rounds] [-l saltlength] [-s salt]\n");
+  printf("                           [-p plaintext]\n");
+  printf("         Raw:  mkpasswd -R <rawsalt> [-p plaintext]\n");
+  printf("Use -h for full usage\n");
   exit(0);
 }
